Subject: Re: [PATCH net] netlink: preserve netlink pkt_type on dev_queue_xmit_nit

From: Daniel Borkmann <[email-masked]>
Date: Sun, 13 Apr 2014 20:12:34 +0200

On 04/12/2014 11:02 PM, David Miller wrote:
...
> I really don't like the idea of treating some packets that go out of
> dev_queue_xmit_nit() as one type, and others of another type.

Understood and agreed, fwiw, I was fighting with myself and don't really
like it either.

> Because dammit, if the packet is going through this function it very
> much is PACKET_OUTGOING.
>
> It's outgoing to your special netlink tap device in this case right?

Yep; it's of course still outgoing, just tells more specific if it has
been sent from user space or kernel space, thus it preserves PACKET_USER
and PACKET_KERNEL (as otherwise overwritten -- it's for user space to
tell from which direction the skb has been sent). I'll think about it
further and already have some other ideas to try out that are hopefully
more generic/acceptable. Anyway, thanks for your feedback.